'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var vue = require('vue');
var lodashUnified = require('lodash-unified');
var index$7 = require('../../radio/index.js');
var index$6 = require('../../icon/index.js');
require('../../../directives/index.js');
var index$4 = require('../../tooltip/index.js');
var index$5 = require('../../input/index.js');
require('../../../hooks/index.js');
require('../../../constants/index.js');
require('../../../utils/index.js');
var iconsVue = require('@element-plus/icons-vue');
var alphaSlider = require('./components/alpha-slider.js');
var hueSlider = require('./components/hue-slider.js');
var predefine = require('./components/predefine.js');
var svPanel = require('./components/sv-panel.js');
var color = require('./utils/color.js');
var colorPicker = require('./color-picker2.js');
var core = require('@vueuse/core');
var pluginVue_exportHelper = require('../../../_virtual/plugin-vue_export-helper.js');
var index = require('../../../hooks/use-locale/index.js');
var index$1 = require('../../../hooks/use-namespace/index.js');
var index$2 = require('../../../hooks/use-form-item/index.js');
var index$3 = require('../../../hooks/use-common-props/index.js');
var event = require('../../../constants/event.js');
var error = require('../../../utils/error.js');
var index$8 = require('../../../directives/click-outside/index.js');

const _hoisted_1 = ["id", "aria-label", "aria-labelledby", "aria-description", "tabindex", "onKeydown"];
const _hoisted_2 = /* @__PURE__ */ vue.createElementVNode("svg", {
  viewBox: "0 0 24 24",
  id: "icon-icon_down_outlined-1"
}, [
  /* @__PURE__ */ vue.createElementVNode("path", { d: "m12 15.864 8.132-8.132a.5.5 0 0 1 .707 0l.707.707a.5.5 0 0 1 0 .707l-8.839 8.84a1 1 0 0 1-1.414 0l-8.839-8.84a.5.5 0 0 1 0-.707l.707-.707a.5.5 0 0 1 .707 0L12 15.864Z" })
], -1);
const __default__ = vue.defineComponent({
  name: "ElColorPicker"
});
const _sfc_main = /* @__PURE__ */ vue.defineComponent({
  ...__default__,
  props: colorPicker.colorPickerProps,
  emits: colorPicker.colorPickerEmits,
  setup(__props, { expose, emit }) {
    var _a, _b;
    const props = __props;
    const { isSupported, open, sRGBHex } = core.useEyeDropper();
    const { t } = index.useLocale();
    const ns = index$1.useNamespace("color");
    const { formItem } = index$2.useFormItem();
    const colorSize = index$3.useSize();
    const colorDisabled = index$3.useDisabled();
    const { inputId: buttonId, isLabeledByFormItem } = index$2.useFormItemInputId(props, {
      formItemContext: formItem
    });
    const hue = vue.ref();
    const sv = vue.ref();
    const alpha = vue.ref();
    const popper = vue.ref();
    let shouldActiveChange = true;
    const color$1 = vue.reactive(new color["default"]({
      enableAlpha: props.showAlpha,
      format: props.colorFormat || ((_a = props.modelValue) == null ? void 0 : _a.startsWith("#")) ? "hex" : "rgb",
      value: props.modelValue
    }));
    const showPicker = vue.ref(false);
    const showPanelColor = vue.ref(false);
    const customInput = vue.ref("");
    const displayedColor = vue.computed(() => {
      if (!props.modelValue && !showPanelColor.value) {
        return "transparent";
      }
      return displayedRgb(color$1, props.showAlpha);
    });
    const showBorder = vue.computed(() => {
      return ["rgb(255, 255, 255)", "rgba(255, 255, 255, 1)", "#FFFFFFFF", "#FFFFFF"].includes(props.modelValue);
    });
    const computdTriggerWidth = vue.computed(() => {
      return colorSize.value === "large" ? props.triggerWidth + 18 : props.triggerWidth;
    });
    const computdTriggeIconWidth = vue.computed(() => {
      return colorSize.value === "large" ? computdTriggerWidth.value * 2 - 67 : computdTriggerWidth.value * 2 - 62;
    });
    const getEyeDropper = () => {
      if (!isSupported)
        return;
      open();
    };
    const colorMode = vue.ref(((_b = props.modelValue) == null ? void 0 : _b.startsWith("#")) ? "HEX" : "RGB");
    const currentColor = vue.computed(() => {
      return !props.modelValue && !showPanelColor.value ? "" : color$1.value;
    });
    const modeChange = (val) => {
      color$1.format = val.toLowerCase();
      handleConfirm();
      customInput.value = color$1.value;
    };
    function customInputChange() {
      handleConfirm();
      customInput.value = color$1.value;
      confirmValue();
    }
    const buttonAriaLabel = vue.computed(() => {
      return !isLabeledByFormItem.value ? props.label || t("el.colorpicker.defaultLabel") : void 0;
    });
    const buttonAriaLabelledby = vue.computed(() => {
      return isLabeledByFormItem.value ? formItem == null ? void 0 : formItem.labelId : void 0;
    });
    const btnKls = vue.computed(() => {
      return [
        ns.b("picker"),
        ns.is("disabled", colorDisabled.value),
        ns.is("custom", props.isCustom),
        ns.is("effect", props.effect === "dark"),
        ns.bm("picker", colorSize.value)
      ];
    });
    function displayedRgb(color2, showAlpha) {
      if (!(color2 instanceof color["default"])) {
        throw new TypeError("color should be instance of _color Class");
      }
      const { r, g, b } = color2.toRgb();
      return showAlpha ? `rgba(${r}, ${g}, ${b}, ${color2.get("alpha") / 100})` : `rgb(${r}, ${g}, ${b})`;
    }
    function setShowPicker(value) {
      showPicker.value = value;
    }
    const debounceSetShowPicker = lodashUnified.debounce(setShowPicker, 100);
    function show() {
      setTimeout(() => {
        if (colorDisabled.value)
          return;
        setShowPicker(true);
      }, 100);
    }
    function hide() {
      debounceSetShowPicker(false);
      resetColor();
    }
    function resetColor() {
      vue.nextTick(() => {
        if (props.modelValue) {
          color$1.fromString(props.modelValue);
        } else {
          color$1.value = "";
          vue.nextTick(() => {
            showPanelColor.value = false;
          });
        }
      });
    }
    function handleTrigger() {
      if (colorDisabled.value)
        return;
      debounceSetShowPicker(!showPicker.value);
    }
    function handleConfirm() {
      color$1.fromString(customInput.value);
    }
    function confirmValue() {
      const value = color$1.value;
      emit(event.UPDATE_MODEL_EVENT, value);
      showPicker.value && emit("change", value);
      if (props.validateEvent) {
        formItem == null ? void 0 : formItem.validate("change").catch((err) => error.debugWarn(err));
      }
      vue.nextTick(() => {
        const newColor = new color["default"]({
          enableAlpha: props.showAlpha,
          format: props.colorFormat || "",
          value: props.modelValue
        });
        if (!color$1.compare(newColor)) {
          resetColor();
        }
      });
    }
    function clear() {
      debounceSetShowPicker(false);
      emit(event.UPDATE_MODEL_EVENT, null);
      emit("change", null);
      if (props.modelValue !== null && props.validateEvent) {
        formItem == null ? void 0 : formItem.validate("change").catch((err) => error.debugWarn(err));
      }
      resetColor();
    }
    vue.onMounted(() => {
      if (props.modelValue) {
        customInput.value = currentColor.value;
      }
    });
    vue.watch(() => props.modelValue, (newVal) => {
      if (!newVal) {
        showPanelColor.value = false;
      } else if (newVal && newVal !== color$1.value) {
        shouldActiveChange = false;
        color$1.fromString(newVal);
      }
    });
    vue.watch(sRGBHex, (newValue) => {
      color$1.fromString(newValue);
      customInput.value = color$1.value;
    });
    vue.watch(() => customInput.value, (newValue, oldValue) => {
      if (newValue !== oldValue) {
        confirmValue();
      }
    });
    vue.watch(() => currentColor.value, (val) => {
      customInput.value = val;
      shouldActiveChange && emit("activeChange", val);
      shouldActiveChange = true;
    });
    vue.watch(() => color$1.value, () => {
      if (!props.modelValue && !showPanelColor.value) {
        showPanelColor.value = true;
      }
    });
    vue.watch(() => showPicker.value, () => {
      vue.nextTick(() => {
        var _a2, _b2, _c;
        (_a2 = hue.value) == null ? void 0 : _a2.update();
        (_b2 = sv.value) == null ? void 0 : _b2.update();
        (_c = alpha.value) == null ? void 0 : _c.update();
      });
    });
    vue.provide(colorPicker.colorPickerContextKey, {
      currentColor
    });
    expose({
      color: color$1,
      show,
      hide
    });
    return (_ctx, _cache) => {
      return vue.openBlock(), vue.createBlock(vue.unref(index$4.ElTooltip), {
        ref_key: "popper",
        ref: popper,
        visible: showPicker.value,
        "show-arrow": false,
        "fallback-placements": ["bottom", "top", "right", "left"],
        offset: 0,
        "gpu-acceleration": false,
        "popper-class": [vue.unref(ns).be("picker", "panel"), vue.unref(ns).b("dropdown"), _ctx.popperClass],
        "stop-popper-mouse-event": false,
        effect: _ctx.effect,
        trigger: "click",
        transition: `${vue.unref(ns).namespace.value}-zoom-in-top`,
        persistent: ""
      }, {
        content: vue.withCtx(() => [
          vue.withDirectives((vue.openBlock(), vue.createElementBlock("div", null, [
            vue.createElementVNode("div", {
              class: vue.normalizeClass(vue.unref(ns).be("dropdown", "main-wrapper"))
            }, [
              vue.createVNode(hueSlider["default"], {
                ref_key: "hue",
                ref: hue,
                class: "hue-slider",
                color: vue.unref(color$1),
                vertical: ""
              }, null, 8, ["color"]),
              vue.createVNode(svPanel["default"], {
                ref_key: "sv",
                ref: sv,
                color: vue.unref(color$1)
              }, null, 8, ["color"])
            ], 2),
            _ctx.showAlpha ? (vue.openBlock(), vue.createBlock(alphaSlider["default"], {
              key: 0,
              ref_key: "alpha",
              ref: alpha,
              color: vue.unref(color$1)
            }, null, 8, ["color"])) : vue.createCommentVNode("v-if", true),
            _ctx.predefine ? (vue.openBlock(), vue.createBlock(predefine["default"], {
              key: 1,
              ref: "predefine",
              color: vue.unref(color$1),
              colors: _ctx.predefine
            }, null, 8, ["color", "colors"])) : vue.createCommentVNode("v-if", true),
            vue.createElementVNode("div", {
              onClick: _cache[4] || (_cache[4] = vue.withModifiers(() => {
              }, ["stop"])),
              class: vue.normalizeClass(vue.unref(ns).be("dropdown", "btns"))
            }, [
              vue.createElementVNode("span", {
                class: vue.normalizeClass(vue.unref(ns).be("dropdown", "value"))
              }, [
                vue.createVNode(vue.unref(index$5.ElInput), {
                  modelValue: customInput.value,
                  "onUpdate:modelValue": _cache[0] || (_cache[0] = ($event) => customInput.value = $event),
                  onKeydown: _cache[1] || (_cache[1] = vue.withModifiers(() => {
                  }, ["stop"])),
                  onKeyup: [
                    _cache[2] || (_cache[2] = vue.withModifiers(() => {
                    }, ["stop"])),
                    vue.withKeys(handleConfirm, ["enter"])
                  ],
                  "validate-event": false,
                  size: "small",
                  onBlur: customInputChange
                }, null, 8, ["modelValue", "onKeyup"])
              ], 2),
              vue.createVNode(vue.unref(index$6.ElIcon), {
                onClick: vue.withModifiers(getEyeDropper, ["stop"])
              }, {
                default: vue.withCtx(() => [
                  vue.createVNode(vue.unref(iconsVue.EditPen))
                ]),
                _: 1
              }, 8, ["onClick"]),
              vue.createVNode(vue.unref(index$7.ElRadioGroup), {
                onChange: modeChange,
                modelValue: colorMode.value,
                "onUpdate:modelValue": _cache[3] || (_cache[3] = ($event) => colorMode.value = $event),
                size: "small"
              }, {
                default: vue.withCtx(() => [
                  vue.createVNode(vue.unref(index$7.ElRadioButton), { label: "HEX" }),
                  vue.createVNode(vue.unref(index$7.ElRadioButton), { label: "RGB" })
                ]),
                _: 1
              }, 8, ["modelValue"]),
              vue.createCommentVNode(` <el-button
            :class="ns.be('dropdown', 'link-btn')"
            text
            size="small"
            @click="clear"
          >
            {{ t('el.colorpicker.clear') }}
          </el-button>
          <el-button
            plain
            size="small"
            :class="ns.be('dropdown', 'btn')"
            @click="confirmValue"
          >
            {{ t('el.colorpicker.confirm') }}
          </el-button> `)
            ], 2)
          ])), [
            [vue.unref(index$8["default"]), hide]
          ])
        ]),
        default: vue.withCtx(() => [
          vue.createElementVNode("div", {
            id: vue.unref(buttonId),
            class: vue.normalizeClass(vue.unref(btnKls)),
            role: "button",
            "aria-label": vue.unref(buttonAriaLabel),
            "aria-labelledby": vue.unref(buttonAriaLabelledby),
            "aria-description": vue.unref(t)("el.colorpicker.description", { color: _ctx.modelValue || "" }),
            tabindex: _ctx.tabindex,
            onKeydown: vue.withKeys(handleTrigger, ["enter"])
          }, [
            vue.unref(colorDisabled) ? (vue.openBlock(), vue.createElementBlock("div", {
              key: 0,
              class: vue.normalizeClass(vue.unref(ns).be("picker", "mask"))
            }, null, 2)) : vue.createCommentVNode("v-if", true),
            vue.createElementVNode("div", {
              style: vue.normalizeStyle(_ctx.isCustom ? { width: vue.unref(computdTriggerWidth) ? vue.unref(computdTriggerWidth) + "px" : "auto" } : {}),
              class: vue.normalizeClass(vue.unref(ns).be("picker", "trigger")),
              onClick: handleTrigger
            }, [
              vue.createElementVNode("span", {
                class: vue.normalizeClass([vue.unref(ns).be("picker", "color"), vue.unref(ns).is("alpha", _ctx.showAlpha), vue.unref(showBorder) && "show-border"])
              }, [
                vue.createElementVNode("span", {
                  class: vue.normalizeClass(vue.unref(ns).be("picker", "color-inner")),
                  style: vue.normalizeStyle({
                    backgroundColor: vue.unref(displayedColor)
                  })
                }, [
                  vue.withDirectives(vue.createVNode(vue.unref(index$6.ElIcon), {
                    style: vue.normalizeStyle(_ctx.isCustom ? { marginLeft: vue.unref(computdTriggerWidth) ? vue.unref(computdTriggeIconWidth) + "px" : "auto" } : {}),
                    class: vue.normalizeClass([vue.unref(ns).be("picker", "icon"), vue.unref(ns).is("icon-arrow-down")])
                  }, {
                    default: vue.withCtx(() => [
                      _hoisted_2
                    ]),
                    _: 1
                  }, 8, ["style", "class"]), [
                    [vue.vShow, _ctx.modelValue || showPanelColor.value]
                  ]),
                  !_ctx.modelValue && !showPanelColor.value ? (vue.openBlock(), vue.createBlock(vue.unref(index$6.ElIcon), {
                    key: 0,
                    class: vue.normalizeClass([vue.unref(ns).be("picker", "empty"), vue.unref(ns).is("icon-close")])
                  }, {
                    default: vue.withCtx(() => [
                      vue.createVNode(vue.unref(iconsVue.Close))
                    ]),
                    _: 1
                  }, 8, ["class"])) : vue.createCommentVNode("v-if", true)
                ], 6)
              ], 2)
            ], 6)
          ], 42, _hoisted_1)
        ]),
        _: 1
      }, 8, ["visible", "popper-class", "effect", "transition"]);
    };
  }
});
var ColorPicker = /* @__PURE__ */ pluginVue_exportHelper["default"](_sfc_main, [["__file", "/Users/st/Desktop/vue/nxx-ui/packages/components/color-picker/src/color-picker.vue"]]);

exports["default"] = ColorPicker;
//# sourceMappingURL=color-picker.js.map
